=== debian/changelog ===
arduino-core-avr (1.8.6+dfsg-2) unstable; urgency=medium

  * Team upload
  * [d3d832c] Add patch adding -fno-jump-tables to makefile (Closes: #1086256),
    thanks to Scott Ashcroft

 -- Matthias Geiger <werdahias@debian.org>  Wed, 19 Mar 2025 20:06:26 +0100

arduino-core-avr (1.8.6+dfsg-1) unstable; urgency=medium

  * [0ef762f] New upstream version 1.8.6+dfsg
  * [76c9b53] Rebuild patch queue from patch-queue branch
  * [254a970] d/control: Update Standards-Version to 4.6.0
    No further changes needed.
  * [31e1641] Lintian: Adjust overrides to new syntax

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 06 Nov 2022 07:27:21 +0100
