=== debian/control ===
Source: arduino-core-avr
Section: utils
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
Uploaders:
 Carsten Schoenert <c.schoenert@t-online.de>,
Build-Depends:
 avr-libc,
 debhelper-compat (= 13),
 gcc-avr,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/arduino/ArduinoCore-avr
Vcs-Browser: https://salsa.debian.org/electronics-team/arduino/arduino-core-avr
Vcs-Git: https://salsa.debian.org/electronics-team/arduino/arduino-core-avr.git

Package: arduino-core-avr
Architecture: all
Depends:
 avr-libc,
 gcc-avr,
 ${misc:Depends},
Description: Arduino Core for AVR microcontroller
 This package contains the source code and configuration files of the Arduino
 Core for Atmel's AVR microcontroller used on the Arduino Yún, Uno, Uno WiFi,
 Diecimila, Nano, Mega, MegaADK, Leonardo, Leonardo Ethernet, Micro, Esplora,
 Min, Ethernet, Fio, BT, LilyPadUSB, Lilypad, Pro, ATMegaNG, Robot Control,
 Robot Motor, Gemma, Yún Mini and Industrial 101.
 .
 It also contains some basic interfaces for interacting with the
 internal non-volatile storage (aka EEPROM) in AVR based Arduino boards.
 Also interfaces for interacting with plugable USB infrastructure (HID),
 for the Serial Programming Interface (SPI), for serial communication on
 any digital pins and for communicaton by I2C and Two Wire Interfaces
 devices.
 .
 Please note that the firmware for the Arduino WiFi Shield is not included
 (in contrary to the official upstream archive) due it's non DFSG compliance!
 Also some *.hex files are excluded as they are not rebuildable.
