## arduino-core-avr 1.8.7+dfsg

=== debian/changelog ===
arduino-core-avr (1.8.7+dfsg-1) unstable; urgency=medium

  * Team upload
  * [6840e74] New upstream version 1.8.7+dfsg (Closes: #1126285) (CVE-2025-69209)
  * [f497c6e] d/copyright: Adjust excludes list
  * [a9b845a] Refresh patches for new upstream release
  * [c386188] d/control: Bump S-V to 4.7.3; drop priority: optional and RRR
  * [95bf24d] Update lintian overrides for avr bootloader files

 -- Matthias Geiger <werdahias@debian.org>  Fri, 30 Jan 2026 13:56:33 +0100
