=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: arduino-core-avr
 Section: utils
-Priority: optional
 Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
 Uploaders:
  Carsten Schoenert <c.schoenert@t-online.de>,
@@ -8,8 +7,7 @@
  avr-libc,
  debhelper-compat (= 13),
  gcc-avr,
-Standards-Version: 4.6.1
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://github.com/arduino/ArduinoCore-avr
 Vcs-Browser: https://salsa.debian.org/electronics-team/arduino/arduino-core-avr
 Vcs-Git: https://salsa.debian.org/electronics-team/arduino/arduino-core-avr.git
